package model

type SelfSupportForUserConsumeLimit struct {
	Id                                 int    `json:"id" xorm:"not null pk autoincr INT(11)"`
	EnterpriseId                       int    `json:"enterprise_id" xorm:"not null default 0 comment('单位id') INT(11)"`
	UserIdentityId                     int    `json:"user_identity_id" xorm:"not null default 0 comment('用户身份id') INT(11)"`
	DailyConsumeLimit                  string `json:"daily_consume_limit" xorm:"not null default '' comment('单日金额上限,上限999') CHAR(50)"`
	SingleConsumeLimit                 string `json:"single_consume_limit" xorm:"not null default '' comment('单笔金额上限,上限99') CHAR(50)"`
	DailyMaxConsumeTimes               string `json:"daily_max_consume_times" xorm:"not null default '' comment('单日最大消费次数,上限99(如需设置需要大于餐段次数之和,否则可能会导致餐段消费次数不足)') CHAR(50)"`
	RosterPeriodConsumeLimitConfigList string `json:"roster_period_consume_limit_config_list" xorm:"not null comment('餐段设置，如需设置支持2-4个餐段。餐段时间不能有重叠') TEXT"`
	CreateAt                           string `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' DATETIME"`
	UpdateAt                           string `json:"update_at" xorm:"not null default 'CURRENT_TIMESTAMP' DATETIME"`
}
